# -*- coding:utf-8 -*-
import argparse
import os

import pytest

from unit.public.DataDic import DataDic

dd = DataDic()


def py_run():
    """命令行参数解析"""
    parser = argparse.ArgumentParser(description=u'可选择参数：')
    parser.add_argument("--client", default='localhost', help="client：客户端IP")
    parser.add_argument("--project", default='GuKeYiTiHua', help="project：项目")
    # url: 'http://scdev.cmic.com.cn:8088/beta/r/w'
    parser.add_argument("--url", default='http://scdev.cmic.com.cn:8088/beta/r/w', help="url: 地址")
    # ;手术跟台: surgery | 采购管理:purchase | 调拨管理: Transfer | 库存管理:inventory | 调试:debug
    parser.add_argument("--module", default='surgery', help="module：模块")
    parser.add_argument("--tab", default='surgery', help="tab：标记")
    parser.add_argument("--order", help="order: 单据编码")
    parser.add_argument("--co", help="co: 公司")
    parser.add_argument("--wh", help="wh: 仓库")
    parser.add_argument("--good", help="good: 商品")
    parser.add_argument("--num", help="num: 数量")
    args = parser.parse_args()
    dd.set_value('client', args.client)
    dd.set_value('project', args.project)
    dd.set_value('url', args.url)
    dd.set_value('module', args.module)
    dd.set_value('tab', args.tab)
    dd.set_value('order', args.order)
    dd.set_value('company', args.co)
    dd.set_value('warehouse', args.wh)
    dd.set_value('custGood', args.good)
    dd.set_value('custNum', args.num)

    tab_code = dd.get_value('tab')
    if tab_code is None:
        pytest.main(['cases/UI/{}/{}'.format(dd.get_value('project'), dd.get_value('module'))])
    else:
        pytest.main(
            ['cases/UI/{}/{}'.format(dd.get_value('project'), dd.get_value('module')), '-m', tab_code])
    # allure generate allure-results -o allure-report --clean
    os.system("allure generate allure-results -o allure-report --clean")


if __name__ == '__main__':
    py_run()
